ljEvents = new Object();

ljEvents.getEventsChallenge = function() {
	this.httpreq = new XMLHttpRequest()
	this.httpreq.onload = this.challengeHandler.onResult;
	this.httpreq.onerror = this.challengeHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
}

ljEvents.challengeHandler = {
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljEvents.httpreq.responseText) == "OK") {
			var challenge = LiveJournal.getResponseData("challenge", ljEvents.httpreq.responseText);
			ljEvents.getEvents(challenge);
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljEvents.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}

ljEvents.getEvents = function(challengestring) {
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.eventsHandler.onResult;
	this.httpreq.onerror = this.eventsHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	var params = new Object();
	
	params.user = LiveJournal.username;
	params.auth_method = "challenge";
	params.auth_challenge = challengestring;
	params.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	params.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		params.usejournal = ljPost.usejournal;
	}
	params.truncate = 40;
	params.prefersubject = true;
	params.noprops = true;
	params.selecttype = "day";
	params.year = dsCalendar.year;
	params.month = dsCalendar.month + 1;
	params.day = dsCalendar.selectedday;
	params.lineendings = "space";

	var body = "mode=getevents";
	body += LiveJournal.makeParams(params);
	
	this.httpreq.send(body);
}

ljEvents.eventsHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljEvents.httpreq.responseText) == "OK") {
			var result = ljEvents.httpreq.responseText;
			var eventlist = document.getElementById("entrieslist");
			while (eventlist.childNodes.length > 2) {
				eventlist.removeChild(eventlist.lastChild);
			}
			for (i = 1; i <= parseInt(LiveJournal.getResponseData("events_count", result), 10); i++) {
				var eventtime = LiveJournal.getResponseData("events_" + i + "_eventtime", result);
				var event = LiveJournal.getResponseData("events_" + i + "_event", result);
				var eventid = LiveJournal.getResponseData("events_" + i + "_itemid", result);
				eventid += "|";
				eventid += LiveJournal.getResponseData("events_" + i + "_anum", result);
				eventlist.appendChild(document.createElement("listitem"));
				eventlist.lastChild.setAttribute("value", eventid);
				eventlist.lastChild.setAttribute("ondblclick", "EditPost(this);");
				eventlist.lastChild.setAttribute("label", FixClock(eventtime));
				eventlist.lastChild.appendChild(document.createElement("listcell"));
				eventlist.lastChild.lastChild.setAttribute("label", event);
			}
			document.getElementById("progressdeck").selectedIndex = 1;
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljEvents.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}
